#pragma once
#include <vector>

using namespace std;

//vector addition and subtraction and multiplication
vector<double> vector_add(vector<double> vector1, vector<double> vector2)
{
	vector<double> result;
	for (int i = 0; i < vector1.size(); i++)
		result.push_back(vector1[i] + vector2[i]);
	return result;
}
vector<double> vector_subtract(vector<double> vector1, vector<double> vector2)
{
	vector<double> result;
	for (int i = 0; i < vector1.size(); i++)
		result.push_back(vector1[i] - vector2[i]);
	return result;
}
vector<double> scalar_multiplication(double scalar, vector<double> vector1)
{
	vector<double> result;
	for (int i = 0; i < vector1.size(); i++)
		result.push_back(vector1[i] * scalar);
	return result;
}

//returns magnitude of vector
double magnitude(vector<double> vector1)
{
	double square_sum = 0.0;
	for (int i = 0; i < vector1.size(); i++)
		square_sum += pow(vector1[i], 2);
	return pow(square_sum, 0.5);
}

//normalized vector (magnitude == 1)
vector<double> normalize(vector<double> vector1)
{
	vector<double> result;
	double size = magnitude(vector1);
	for (int i = 0; i < vector1.size(); i++)
		result.push_back(vector1[i] / size);
	return result;
}